using System;

namespace transfuzija_krvi
{
    class Program
    {
        static void Main(string[] args)
        {
            bool ok = true;
            int N = int.Parse(Console.ReadLine());
            string[] s = Console.ReadLine().Split();
            int O = int.Parse(s[0]);
            int A = int.Parse(s[1]);
            int B = int.Parse(s[2]);
            int AB = int.Parse(s[3]);
            string[] a = new string[N];
            int[] b = new int[N];
            for (int i = 0; i < N; i++)
            {
                s = Console.ReadLine().Split();
                a[i] = s[0];
                b[i] = int.Parse(s[1]);
            }
            for (int i = 0; i < N; i++)
            {
                if (a[i] == "O")
                {
                    if (O > b[i])
                        O -= b[i];
                    else
                        ok = false;
                }
                else if (a[i] == "A")
                {
                    if (A >= b[i])
                        A -= b[i];
                    else if (A > 0 && A < b[i])
                    {
                        b[i] -= A;
                        A -= b[i];
                        if (O >= b[i])
                            O -= b[i];
                        else
                            ok = false;
                    }
                    else if (O > b[i])
                        O -= b[i];
                    else
                        ok = false;
                }
                else if (a[i] == "B")
                {
                    if (B >= b[i])
                        B -= b[i];
                    else if (B > 0 && B < b[i])
                    {
                        b[i] -= B;
                        B -= b[i];
                        if (O >= b[i])
                            O -= b[i];
                        else
                            ok = false;
                    }
                }
                else if (a[i] == "AB")
                {
                    if (AB >= b[i])
                        AB -= b[i];
                    else if (AB > 0 && AB < b[i])
                    {
                        b[i] -= AB;
                        AB -= b[i];
                        if (A >= b[i])
                            A -= b[i];
                        else if (B >= b[i])
                            B -= b[i];
                        else if (O >= b[i])
                            O -= b[i];
                        else
                            ok = false;
                    }
                    else if (AB == 0)
                    {
                        if (A > 0 || B > 0)
                        {
                            if (A >= b[i])
                                A -= b[i];
                            else if (A < b[i])
                            {
                                b[i] -= A;
                                A -= b[i];
                                if (B > b[i])
                                    B -= b[i];
                                else if (O > b[i])
                                    O -= b[i];
                                else
                                    ok = false;
                            }
                        }
                        else if (O >= b[i])
                            O -= b[i];
                        else
                            ok = false;
                    }
                }
            }
            if (ok)
                Console.WriteLine("moguce");
            else
                Console.WriteLine("nemoguce");
        }
    }
}